package descartes.kieker4dql.dqlconnector.structures;



public class ResourceContent {


	public static final int NONE =0;
	public static final int TIME_INTERVAL=1;
	public static final int UTILIZATION=2;
	public static final int IDLE=3;
	public static final int WAIT=4;
	public static final int IRQ=5;
	public static final int NICE=6;
	public static final int SYSTEM=7;
	public static final int USER=8;
	public static final int MEM_TOTAL=9;
	public static final int MEM_USED=10;
	public static final int MEM_FREE=11;
	public static final int SWAP_TOTAL=12;
	public static final int SWAP_USED=13;
	public static final int SWAP_FREE=14;
	public static final int BUSY=15;

	public static final int UPPER_BOUND=16;

	private final String[] names = {
			"NONE" ,
			"TIME_INTERVAL" ,
			"UTILIZATION" ,
			"IDLE" ,
			"WAIT" ,
			"IRQ" ,
			"NICE" ,
			"SYSTEM" ,
			"USER" ,
			"MEM_TOTAL" ,
			"MEM_USED" ,
			"MEM_FREE" ,
			"SWAP_TOTAL" ,
			"SWAP_USED" ,
			"SWAP_FREE" ,
			"BUSY" 
	};


	private double[] content = new double[UPPER_BOUND];
	private int idx;
	private final ResourceContentType type;


	public ResourceContent(ResourceContentType type) {
		this.type=type;
	}


	public void setCurrentPointer(int idx) {
		this.idx =idx;
	}

	public int getCurrentPointer() {
		return idx;
	}

	public void set(int idx , Double content){
		this.idx =idx;
		this.content[idx]=content;
	}

	public double get(int idx) {
		return content[idx];
	}

	public String getName(int idx) {
		return names[idx];
	}

	public double[] getAllValues() {
		return content.clone();
	}

	public String toString() {
		StringBuilder builder = new StringBuilder();
		for (int i = 0; i < content.length; i++) {
			builder.append(String.format("%-15s", names[i]));
			builder.append("\t = ");
			builder.append(content[i]);

			builder.append("; \n");
		}
		return builder.toString();
	}


	public enum ResourceContentType {
		NONE,MEM_SWAP,CPU;
	}

	public ResourceContentType getType() {
		return type;
	}
}
